'Quick'n'Dirty-Simulation meines DCF77-Signalfilters
'Copyright (C) 2009 Paul Wilhelm <paul@mosfetkiller.de>
'http://mosfetkiller.de/?s=werkzeugkoffer#dcf77signalfilter
'
'Compile w/ FreeBASIC 0.20.0

screen 20

color 15,15
cls

dim as integer seconds = 5 '5 sekunden * 100 samples

dim as integer sample
dim as integer counter
dim as integer rst = 0

'grafik (vergrerung)
dim as integer xoff = 10, yoff = 100
dim as single stretchx = 4, stretchy = 1
dim as integer counterstretch = 4

'parameter
dim as integer counterthreshold = 6
dim as integer levelthreshold = 11
dim as integer syncthreshold = 107

dim as integer lastreset = 0, resets = 0

dim as integer oldx = xoff, oldy = yoff
dim as integer oldxcounter = xoff, oldycounter = 100 * stretchy + yoff
line (oldx, oldy + 100 * stretchy + 2)-(oldx + 100 * seconds * stretchx - 1, oldy + 100 * stretchy + 2), 7

for x = 0 to 100 * seconds - 1
    
    'sample erfassen
    read sample
    
    'signal zeichnen
    dim as integer newx = x * stretchx + xoff, newy = 100 * stretchy - sample * 100 * stretchy + yoff
    line (oldx, oldy)-(newx, newy), 0
    oldx = newx
    oldy = newy
    
    if sample = 0 then
        'inkrementieren
        counter = counter + counterstretch
    else
        'dekrementieren wenn > 0
        if counter > 0 then counter = counter - counterstretch
    end if

    'reset bei grenzwertberschreitung durchfhren
    if counter >= counterstretch * counterthreshold then
        'counter resetten
        counter = 0
        
        'resetzhler inkrementieren
        resets = resets + 1
        
        'letzter reset ist genau jetzt (liegt 0 samples zurck)
        lastreset = 0
        
        circle(oldxcounter, oldycounter), 3, 2
        paint(oldxcounter, oldycounter), 2
    end if
    
    dim as integer newxcounter = x * stretchx + xoff
    dim as integer newycounter = 100 * stretchy - counter + yoff
    line (oldxcounter, oldycounter)-(newxcounter, newycounter), 1
    oldxcounter = newxcounter
    oldycounter = newycounter
    
    'samplezhler seit dem letzten reset inkrementieren
    lastreset = lastreset + 1

    'level erfassen
    if lastreset >= levelthreshold then
        if resets = 1 then
            '1 reset: low (leeren kreis zeichnen)
            circle(newxcounter, 100 * stretchy + yoff + 20), 5, 4
        elseif resets > 1 then
            'mehr als 1 reset: high (rot gefllten kreis zeichnen)
            circle(newxcounter, 100 * stretchy + yoff + 20), 5, 4
            paint(newxcounter, 100 * stretchy + yoff + 20), 4
        end if
        
        resets = 0
    end if

    'sync erfassen
    if lastreset >= syncthreshold then
        lastreset = 0

        circle(newxcounter, 100 * stretchy + yoff + 20), 5, 1
        paint(newxcounter, 100 * stretchy + yoff + 20), 1
    end if
    
next x

sleep

'spikes in high-phasen eingebaut
'1. sekunde: low
'data 1,1,1,1,1,1,1,1,1,1 <--- Abschneiden
'data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 0,0,0,0,1,0,1,0,0,0

'2. sekunde: high
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 0,0,0,0,0,0,0,0,0,0
data 0,0,0,0,0,0,0,0,0,0

'3. sekunde: sync
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1

'4. sekunde: low
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 0,0,0,0,0,0,0,0,0,0

'5. sekunde: low
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 1,1,1,1,1,1,1,1,1,1
data 0,0,0,0,0,0,0,0,0,0

data 1,1,1,1,1,1,1,1,1,1 '<--- Anhngen
data 1,1,1,1,1,1,1,1,1,1
